package com.iohao.mmo.equip.service;

/**
 * @author 唐斌
 * @date 2023-08-31
 * @description:
 */

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

/**
 * JAVA 返回随机数，并根据概率、比率
 *
 */
public class MathRandom {

    private static Log logger = LogFactory.getLog(MathRandom.class);

    /**
     * Math.random()产生一个double型的随机数，判断一下 每个奖品出现的概率
     *
     * @return int
     *
     */
    public int PercentageRandom(List<RewardPrize> prizes) {
        DecimalFormat df = new DecimalFormat("######0.00");
        int random = -2;
        try{
            double sumWeight = 0;
            //计算总权重
            for(RewardPrize rp_1 : prizes){
                sumWeight += rp_1.getPrize_weight();
            }
            double randomNumber;
            randomNumber = Math.random();
//            System.out.println("randomNumber是：" + randomNumber);
            double d1 = 0;
            double d2 = 0;

            for(int i=0;i<prizes.size();i++){
                d2 += Double.parseDouble(String.valueOf(prizes.get(i).getPrize_weight()))/sumWeight;
                if(i==0){
                    d1 = 0;
                }else{
                    d1 +=Double.parseDouble(String.valueOf(prizes.get(i-1).getPrize_weight()))/sumWeight;
                }
                if(randomNumber >= d1 && randomNumber <= d2){
                    random = i;
//                    System.out.println("d1是：" + d1);
//                    System.out.println("d2是：" + d2);
                    break;
                }
            }
        }catch(Exception e){
            System.out.println(e.getMessage());
            logger.error("生成抽奖随机数出错，出错原因：" + e.getMessage());
            random = -1;
        }
        return random;
    }

    /**
     * 测试主程序
     *
     * @param agrs
     */
    public static void main(String[] agrs) {
        int i = 0;
        MathRandom a = new MathRandom();
        List<RewardPrize> prizes = new ArrayList();
        prizes.add(new RewardPrize(10000,"一等奖",1,5));
        prizes.add(new RewardPrize(10001,"二等奖",1,10));
        prizes.add(new RewardPrize(10002,"四等奖",1,30));
        prizes.add(new RewardPrize(10003,"三等奖",1,20));
        prizes.add(new RewardPrize(10004,"安慰奖",1,35));
//        for(int m=0;m<100;m++){
//            RewardPrize rp = new RewardPrize();
//            rp.setPrize_amount(10);//每个奖品数量设置10个
//            rp.setPrize_weight(1);//每个奖品的权重都设置成1，也就是每个奖品被抽到的概率相同（可根据情况自行设置权重）
//            prizes.add(rp);
//        }
        int num1Count = 0;
        int num2Count = 0;
        int num3Count = 0;
        int num4Count = 0;
        int num5Count = 0;
        for (i = 0; i <= 1000000; i++)// 打印100个测试概率的准确性
        {
//            System.out.println(a.PercentageRandom(prizes));
            int index = a.PercentageRandom(prizes);
            if(index==0){
                num1Count++;
            }else if(index==1){
                num2Count++;
            }else if(index==2){
                num3Count++;
            }else if(index==3){
                num4Count++;
            }else if(index==4){
                num5Count++;
            }
        }
        System.out.println(num1Count+"---"+num2Count+"---"+num3Count+"---"+num4Count+"---"+num5Count);

    }
    public static class RewardPrize  {
        private int rewardId;//奖励id
        private String rewardName;//奖励名称
        private int prize_amount;//数量
        private int prize_weight;//权重

        public int getRewardId() {
            return rewardId;
        }

        public void setRewardId(int rewardId) {
            this.rewardId = rewardId;
        }

        public String getRewardName() {
            return rewardName;
        }

        public void setRewardName(String rewardName) {
            this.rewardName = rewardName;
        }

        public int getPrize_amount() {
            return prize_amount;
        }

        public void setPrize_amount(int prize_amount) {
            this.prize_amount = prize_amount;
        }

        public int getPrize_weight() {
            return prize_weight;
        }

        public void setPrize_weight(int prize_weight) {
            this.prize_weight = prize_weight;
        }

        public RewardPrize() {
        }

        public RewardPrize(int rewardId, String rewardName, int prize_amount, int prize_weight) {
            this.rewardId = rewardId;
            this.rewardName = rewardName;
            this.prize_amount = prize_amount;
            this.prize_weight = prize_weight;
        }
    }
}

